require "import"
import "android.view.View"
import "android.widget.Button"
import "android.widget.EditText"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "com.androlua.LuaDialog"

import "android.content.Context"
import "android.os.Vibrator"
import "android.media.ToneGenerator"
import "android.media.AudioManager"
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
local toneGenerator = ToneGenerator(AudioManager.STREAM_NOTIFICATION, 50)
toneGenerator.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200)
vibrator.vibrate(100)
import "android.widget.*"
import "com.androlua.*"

local focusedText = nil -- Variable para guardar el texto enfocado

layout = {
  LinearLayout,
  orientation = LinearLayout.VERTICAL,
  {
    TextView,
    text = "استبدال النصوص",
    textSize = "20sp",
    gravity = "center",
    padding = "16dp",
  },
  {
    EditText,
    id = "editText1",
hint = "أدخِلِ النصَّ الأساسي",
    layout_width = "fill",
    layout_height = "wrap",
  },
  {
    EditText,
    id = "editText2",
    hint = "أدخِلِ النصَّ البديل",
    layout_width = "fill",
    layout_height = "wrap",
  },
  {
    Button,
    text = "استبدال",
    layout_width = "fill",
    layout_height = "wrap",
    onClick = function()
      local oldWord = editText1.getText().toString()
      local newWord = editText2.getText().toString()
      dlg.dismiss()
      vibrator.vibrate(100)
      toneGenerator.startTone(ToneGenerator.TONE_CDMA_EMERGENCY_RINGBACK, 70)
      
      local text = focusedText or "" -- Texto modificado (usar el texto enfocado o una cadena vacía)
      local replacedText = string.gsub(text, oldWord, newWord)

      if replacedText == text then
        service.asyncSpeak("لا يوجد نص مطابُق للنص الاساسي")
      else
        service.setText("" .. replacedText)
focusedText = nil 
      end
    end
  }
}

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
dlg.show()

editText1.setOnFocusChangeListener{
  onFocusChange = function(view, hasFocus)
    if hasFocus then
      focusedText = node.text -- Guardar el texto enfocado en la variable focusedText
    end
  end
}

editText2.setOnFocusChangeListener{
  onFocusChange = function(view, hasFocus)
    if hasFocus then
      focusedText = node.text -- Guardar el texto enfocado en la variable focusedText
    end
  end
}